﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Facebook;
using Microsoft.Phone.Shell;
using System.Windows.Media.Imaging;
using System.IO;

namespace CameraMonster
{
    public partial class Facebook : PhoneApplicationPage
    {
        private FacebookClient client;
        private string token;
        public Facebook()
        {
            InitializeComponent();

            Dictionary<string, object> parameters = new Dictionary<string, object>();
            parameters["response_type"] = "token";
            parameters["display"] = "touch";
            parameters["scope"] = "publish_stream";
            parameters["redirect_uri"] = "https://www.facebook.com/connect/login_success.html";
            parameters["client_id"] = "xxxxxxxxxxxxxxxxxxxx";// <- mettre le code FB ici

            client = new FacebookClient();
            Uri uri = client.GetLoginUrl(parameters);

            wb.Visibility = Visibility.Collapsed;
            wb.Navigate(uri);

            ApplicationBar.Buttons.Clear();

            ApplicationBarIconButton appUploadButton = new ApplicationBarIconButton(new Uri("data/appbar.upload.rest.png", UriKind.Relative));
            appUploadButton.Text = "upload";
            appUploadButton.Click += (e, s) =>
            {
                try
                {
                    if (token == null)
                    {
                        wb.Visibility = Visibility.Visible;
                    }
                    else
                    {
                        ApplicationBar.IsVisible = false;
                        Message.IsEnabled = false;
                        var prog = new ProgressIndicator();
                        prog.IsVisible = true;
                        prog.IsIndeterminate = true;
                        prog.Text = "upload...";

                        SystemTray.SetProgressIndicator(this, prog);
                        postimage();
                    }
                }
                catch (Exception)
                {
                }

            };
            ApplicationBar.Buttons.Add(appUploadButton);


            ApplicationBarIconButton appWallButton = new ApplicationBarIconButton(new Uri("data/fb_wall.png", UriKind.Relative));
            appWallButton.Text = "wall";
            appWallButton.Click += (e, s) =>
            {
                try
                {
                    if (token == null)
                    {
                        wb.Visibility = Visibility.Visible;
                    }
                    else
                    {
                        ApplicationBar.IsVisible = false;
                        Message.IsEnabled = false;
                        var prog = new ProgressIndicator();
                        prog.IsVisible = true;
                        prog.IsIndeterminate = true;
                        prog.Text = "upload...";

                        SystemTray.SetProgressIndicator(this, prog);
                        postmessage();
                    }
                }
                catch (Exception)
                {
                }

            };
            ApplicationBar.Buttons.Add(appWallButton);

            var I = (byte[])App.GetValue("image");
            var bmp = new BitmapImage();
            using (MemoryStream stream = new MemoryStream(I))
            {
                bmp.SetSource(stream);
            }
            image.Source = bmp;

           

        }

        void postmessage()
        {
            var I = (byte[])App.GetValue("image");
           UploadPhoto("me", token, I,true);
        }

        void postimage()
        {
            var I = (byte[])App.GetValue("image");
            UploadPhoto("me", token, I, false);
        }
        public void CreateAlbum(string accessToken, string name/*,EventHandler<FacebookApiEventArgs> ev*/)
        {
            FacebookClient facebookClient = new FacebookClient(accessToken);
            Dictionary<string, object> albumParameters = new Dictionary<string, object>();
            albumParameters.Add("message", "My Album message");
            albumParameters.Add("name", name);
            facebookClient.PostCompleted+= (s, ee) =>
                        {
                            JsonObject data = (JsonObject)ee.GetResultData();
                            string id = (string)data["id"];
                            App.AddOrUpdateValue("id", id);
                            Deployment.Current.Dispatcher.BeginInvoke(delegate()
                   {
                       postimage();
                   });
                        };
            facebookClient.PostAsync("/me/albums", albumParameters);

        }

        public void UploadPhoto(string AlbumId, string accessToken, byte[] fileBytes,bool postmesage)
        {
            FacebookClient facebookClient = new FacebookClient(accessToken);

            FacebookMediaObject mediaObject = new FacebookMediaObject
            {
                FileName = Guid.NewGuid() + ".jpg",
                ContentType = "image/jpeg"
            };
            mediaObject.SetValue(fileBytes);
            IDictionary<string, object> upload = new Dictionary<string, object>();
            if (postmesage)
            {
                upload.Add("name", String.Format("MonsterCam {0:yyyyMMdd-HHmmss}.jpg", DateTime.Now));
            }
            else
            {
                upload.Add("name", Message.Text);
            }
           // upload.Add("message", "test sur l'upload d'une photo");
            //upload.Add("caption", "test sur l'upload d'une photo");
            upload.Add("@file.jpg", mediaObject);

          

         
            facebookClient.PostCompleted += (s, ee) =>
            {
                Deployment.Current.Dispatcher.BeginInvoke(delegate()
                    {
                        if (ee.Error != null)
                        {
                            MessageBox.Show(ee.Error.Message);
                            NavigationService.GoBack();
                        }
                       
                       
                        else
                        {
                            if (postmesage)
                            {
                                JsonObject data = (JsonObject)ee.GetResultData();
                                string id = (string)data["id"];
                                postMessage(token, id);
                            }
                            else
                            {
                                MessageBox.Show("Picture uploaded");
                                NavigationService.GoBack();
                            }
                        }
                    
                    });
            };
            facebookClient.PostAsync("/" + AlbumId + "/photos", upload);

        }

        public void postMessage(string accessToken, string name/*,EventHandler<FacebookApiEventArgs> ev*/)
        {
            FacebookClient facebookClient = new FacebookClient(accessToken);
            Dictionary<string, object> albumParameters = new Dictionary<string, object>();

            //albumParameters.Add("caption", "MonsterCam");
            albumParameters.Add("link", "http://windowsphone.com/s?appid=8ac6c849-7b2f-4fa4-9be4-7e9d5f3e46a2");
            albumParameters.Add("message",  Message.Text);
            albumParameters.Add("object_attachment", name);

          
           
            facebookClient.PostCompleted += (s, ee) =>
            {
                Deployment.Current.Dispatcher.BeginInvoke(delegate()
                {
                    if (ee.Error != null)
                    {
                        MessageBox.Show(ee.Error.Message);
                       
                    }
                    else
                    {
                        MessageBox.Show("Message posted");
                        NavigationService.GoBack();
                    }



                    
                });
            };
            facebookClient.PostAsync("/me/feed", albumParameters);

        }


        private void wb_Navigated(object sender, System.Windows.Navigation.NavigationEventArgs e)
        {
            FacebookOAuthResult result;
            if (client.TryParseOAuthCallbackUrl(e.Uri, out result))
            {
                if (result.IsSuccess)
                {
                    token = result.AccessToken;
                    
                    PhoneApplicationService.Current.State["token"] = token;
                    
                }
                wb.Visibility = Visibility.Collapsed;
            }
        }

        private void wb_NavigationFailed(object sender, System.Windows.Navigation.NavigationFailedEventArgs e)
        {
            MessageBox.Show(e.Exception.Message);
            NavigationService.GoBack();
        }
    }
}